/*********************************************************************NVMH2****
Path:  C:\Dev\devrel\Nv_sdk_4\Dx8\Include
File:  FullCoverageQuad.h

Copyright (C) 1999, 2000 NVIDIA Corporation
This file is provided without support, instruction, or implied warranty of any
kind.  NVIDIA makes no guarantee of its fitness for a particular purpose and is
not liable under any circumstances for any damages or loss whatsoever arising
from the use or inability to use this file or items derived from it.

Comments:

Defines a class to conveniently create and render a single quad which exactly
covers the render target
Use for procedural texture rendering and stencil shadow rendering.

This uses the legacy DX7 pipeline and fixed-function vertex processing.

Draw() will set new WORLD, VIEW, and PROJECTION matrices, so you must restore
these on your own.

******************************************************************************/


#ifndef __FULLCOVERAGEQUAD_H__
#define __FULLCOVERAGEQUAD_H__

#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>
#include <dxerr8.h>





class FullCoverageQuad
{
private:
	typedef struct tagQuadVertex
    {
	    D3DXVECTOR3 Position;
        D3DXVECTOR2 Tex;
    } QuadVertex;


	LPDIRECT3DDEVICE8			m_pD3DDev;
	LPDIRECT3DVERTEXBUFFER8		m_pVertexBuffer;

	D3DXMATRIX					m_mWorldViewProj;
	D3DXMATRIX					m_mIdentity;

	void	SetViewMatrices();

public:


	HRESULT Initialize( LPDIRECT3DDEVICE8 pD3DDev );
	HRESULT Free();

	HRESULT Draw();

	FullCoverageQuad();
	~FullCoverageQuad();
};


#endif












